﻿# -*- coding: UTF-8 -*-
#! /usr/bin/env python3
# wdn RPG2.0;  written by William Dean Napier  1/22/2015
#
# Ideas to implement:
# - Split existing work. Use ....tools.py for this                              - in progress 1/22/2015
# - test split work before enhancing.                                           - in progress 1/22/2015
# - Allow orc to retaliate with 100% chance of hit for AXNC.(do nothing)        - tbd
# - for Ranged and Defense, set orc to 80% effective against R and 50% for D.   - tbd
import random, sys, os, time, winsound, wdnrpgtools

#set variables
health = 100
arrows = 10
arrowdmg = 8
arrowcrit = (arrowdmg + (arrowdmg/2))
sworddur = 30
sworddmg = 10
swordcrit = (sworddmg + (sworddmg/2))
sworddurerrosion = 3
shielddur = 50
shieldblk = 20
shielddmg = 3
shielddurerrosion = 5
handdmg = 3
handcrit = (handdmg + (handdmg/2))
orchp = 375
orcattack = 10
orccrit = (orcattack + (orcattack/2))
playerroll = 0
orcroll = 0
potions = 2
potionhp = 20
chainavail = 2
chaintimes = (1,2,3,4,5)
ninjaavail = 1
ninjatimes = (1,2,3)
totalchaindamage = 0
iterationdamage = 0
menuchoices = "adrhcnx"
choiceflag = 0


#greet the user and give an introduction
wdnrpgtools.greeting()

#allow the user to either play the game or quit
play = input("press \"p\" to play or \"q\" to quit\n")

#input handler get the correct response
while play != "p" and play != "q":
    play = input("incorrect response.  A simple \"p\" or \"q\" will do.")
    

if play == "q":
    quit()

if play == "p":
    #(start of main loop)

    #Clear the screen for a nice clean look
    os.system('cls')
    
    print("An Orc appears!  It's up to you to kill it and save the land.\n")
    input("Press the enter key to continue.")
    #Clear the screen for a nice clean look
    os.system('cls')
    
    while health > 0:
        while choiceflag == 0:
            #Clear the screen for a nice clean look
            os.system('cls')
            # inform user of options, validate input; if not ADRHCX, do nothing or refresh
            # create a range ADRHCX, check inside range.  if input then execute.
            wdnrpgtools.statsandmenu(health, potions, arrows, sworddur, shielddur, chainavail, ninjaavail, orchp)
            action = input("Enter \n\"A\" - Attack, \n\"D\" - Defend, \n\"R\" - Ranged Attack, \n\"H\" - Hand-to-Hand, \n\"X\" - Health Potion, \n\"C\" - Chain Lightning, \n\"N\" - Ninja Attack.")
            print("\n******************************************************************************")
            for i in menuchoices:
                if action == i:
                    choiceflag = 1
                    
            
        
                
        
        

        
        if action == "a":
            playerroll = 0
            orcroll = 0
            choiceflag = 0
            if sworddur > 0:
                print("You swing your sword with all your might!")
                playerroll = random.randint(1, 20)
                if playerroll >= 18:
                    orchp = (orchp - swordcrit)
                    print("Critical Hit! Your cut staggers the Orc.")
                    print("You dealt " + str(swordcrit) + " damage.")
                    print(wdnrpgtools.playerattackscreen())
                    input("Press the enter key to continue.")
                    print("\n\n")
                else:
                    orchp = (orchp - sworddmg)
                    print("You strike true.  The Orc received " + str(sworddmg) + " damage.")
                    print(wdnrpgtools.playerattackscreen())
                    input("Press the enter key to continue.")
                    print("\n\n")
                sworddur = (sworddur - sworddurerrosion)
                orcroll = random.randint(1, 20)
                if orcroll >= 12:
                    if orcroll >= 18:
                        health = (health - orccrit)
                        print("Critical Hit!  The Orc smashes through your defences staggering you.")
                        print("The orc hits you for " + str(orccrit) + " damage.")
                        print(wdnrpgtools.playerattackorcscreen())
                    else:
                        health = (health - orcattack)
                        print("The orc hits you for " + str(orcattack) + " damage.")
                        print(wdnrpgtools.playerattackorcscreen())
                else:
                    print("The Orc missed.")
                
            else:
                print("Your sword is dulled and useless.  Choose another action.")
            input("\nPress the enter key to continue.")
            os.system('cls')
            


            



        if action == "d":
            playerroll = 0
            orcroll = 0
            choiceflag = 0
            if shielddur > 0:
                print("You heft your shield into place and withstand a mighty blow from the Orc!")
                orchp = (orchp - shielddmg)
                print("Your shield bash strikes the Orc for " + str(shielddmg) + " damage.")
                print(wdnrpgtools.playerdefscreen())
                input("Press the enter key to continue.")
                print("\n\n")
                shielddur = (shielddur - shielddurerrosion)
                orcroll = (random.randint(1, 20) *.5) #50% effective against a DEF
                if orcroll >= (12 *.5): #50% effective against a DEF
                    print("The orc hits you for " + str(orcattack/2) + " damage.")
                    health = (health - (orcattack/2))
                    print(wdnrpgtools.playerdeforcscreen())
                else:
                    print("The shield blocks all damage.")
                    print(wdnrpgtools.playerdeforcscreen())
                
            else:
                print("Your shield is sundered and useless.  Choose another action.")
            input("\nPress the enter key to continue.")
            os.system('cls')


            
            
            
            




            

        if action == "r":
            playerroll = 0
            orcroll = 0
            choiceflag = 0
            if arrows > 0:
                print("You jump back equipping your bow.  You nock an arrow and fire!")
                playerroll = random.randint(1, 20)
                if playerroll >= 18:
                    orchp = (orchp - arrowcrit)
                    print("Critical Hit! Your arrow staggers the Orc.")
                    print("You dealt " + str(arrowcrit) + " damage.")
                    print(wdnrpgtools.playerrascreen())
                    input("Press the enter key to continue.")
                    print("\n\n")
                else:
                    orchp = (orchp - arrowdmg)
                    print("Your arrow strikes true.  The Orc received " + str(arrowdmg) + " damage.")
                    print(wdnrpgtools.playerrascreen())
                    input("Press the enter key to continue.")
                    print("\n\n")
                arrows = (arrows - 1)
                orcroll = (random.randint(1, 20) *.8) #80% effective against a RA
                if orcroll >= (12 *.8): #80% effective against a RA
                    if orcroll >= (18 *.8): #80% effective against a RA
                        health = (health - orccrit)
                        print("Critical Hit!  The Orc swats aside your bow staggering you.")
                        print("The orc hits you for " + str(orccrit) + " damage.")
                        print(wdnrpgtools.playerraorcscreen())
                    else:
                        health = (health - orcattack)
                        print("The orc hits you for " + str(orcattack) + " damage.")
                        print(wdnrpgtools.playerraorcscreen())
                else:
                    print("The Orc missed.")
                
            else:
                print("You are out of arrows.  Choose another action.")
            input("\nPress the enter key to continue.")
            os.system('cls')







        
        if action == "h":
            playerroll = 0
            orcroll = 0
            choiceflag = 0
            print("You resort to fists.")
            playerroll = random.randint(1, 20)
            if playerroll >= 18:
                orchp = (orchp - handcrit)
                print("Critical Hit! Your fists of fury staggers the Orc.")
                print("You dealt " + str(handcrit) + " damage.")
                print(wdnrpgtools.playerh2hscreen())
                input("Press the enter key to continue.")
                print("\n\n")
            else:
                orchp = (orchp - handdmg)
                print("You strike the Orc with your fist.  The Orc received " + str(handdmg) + " damage.")
                print(wdnrpgtools.playerh2hscreen())
                input("Press the enter key to continue.")
                print("\n\n")
            orcroll = random.randint(1, 20)
            if orcroll >= 12:
                if orcroll >= 18:
                    health = (health - orccrit)
                    print("Critical Hit!  The Orc swats aside your hands staggering you.")
                    print("The orc hits you for " + str(orccrit) + " damage.")
                    print(wdnrpgtools.playerh2horcscreen())
                else:
                    health = (health - orcattack)
                    print("The orc hits you for " + str(orcattack) + " damage.")
                    print(wdnrpgtools.playerh2horcscreen())
            else:
                print("The Orc missed.")
            
            input("\nPress the enter key to continue.")
            os.system('cls')










        if action == "x":
            playerroll = 0
            orcroll = 0
            choiceflag = 0
            if potions > 0:
                print("Mid fight, you laugh off the Orc's attacks, and drink a health potion.")
                health = (health + potionhp)
                potions -= 1
                print(wdnrpgtools.playerpotionscreen())
                input("Press the enter key to continue.")
                print("\n\n")
                orcroll = random.randint(1, 20)
                if orcroll >= 12:
                    if orcroll >= 18:
                        health = (health - orccrit)
                        print("Critical Hit!  The Orc takes advantage of your drinking habit and bashes you.")
                        print("The orc hits you for " + str(orccrit) + " damage.")
                        print(wdnrpgtools.playerpotionorcscreen())
                    else:
                        health = (health - orcattack)
                        print("The orc hits you anyway; for " + str(orcattack) + " damage.")
                        print(wdnrpgtools.playerpotionorcscreen())
                else:
                    print("The Orc missed.")
                    
            else:
                print("You reach for your potions, but find nothing.  Choose another action.")

            input("\nPress the enter key to continue.")
            os.system('cls')






        if action == "c":
            playerroll = 0
            orcroll = 0
            choiceflag = 0
            totalchaindamage = 0
            iterationdamage = 0
            if chainavail > 0:
                chainavail -= 1
                print("Chanting, you step back arms raised, and fry the Orc with Chained Lightning.")
                #Chained Lightning hits X times, random damage each 1~20.   Assign damage to the Orc.
                for i in chaintimes:
                    iterationdamage = random.randint(1, 20)
                    print("You deal " + str(iterationdamage) + " to the Orc.")
                    totalchaindamage = (totalchaindamage + iterationdamage)
                print("Totalling " + str(totalchaindamage) + ".")
                print(wdnrpgtools.playerchainlscreen())
                orchp = (orchp - totalchaindamage)
                input("Press the enter key to continue.")
                print("\n\n")
                orcroll = random.randint(1, 20)
                if orcroll >= 12:
                    if orcroll >= 18:
                        health = (health - orccrit)
                        print("Critical Hit!  The Orc wades through your lightning to pancake you.")
                        print("The orc hits you for " + str(orccrit) + " damage.")
                        print(wdnrpgtools.playerchainlorcscreen())
                    else:
                        health = (health - orcattack)
                        print("The orc hits you for " + str(orcattack) + " damage.")
                        print(wdnrpgtools.playerchainlorcscreen())
                else:
                    print("The Orc missed.")
                    
            else:
                print("You reach into the ether for more mana but find nothing.  Choose another action.")
            input("\nPress the enter key to continue.")
            #Clear the screen for a nice clean look
            os.system('cls')



        if action == "n":
            playerroll = 0
            orcroll = 0
            choiceflag = 0
            totalninjadamage = 0
            iterationdamage = 0
            if ninjaavail > 0:
                ninjaavail -= 1
                for y in range(0,5):
                    os.system('cls')
                    wdnrpgtools.statsandmenu(health, potions, arrows, sworddur, shielddur, chainavail, ninjaavail, orchp)
                    print("Enter \n\"A\" - Attack, \n\"D\" - Defend, \n\"R\" - Ranged Attack, \n\"H\" - Hand-to-Hand, \n\"X\" - Health Potion, \n\"C\" - Chain Lightning, \n\"N\" - Ninja Attack.")
                    print("\n******************************************************************************")
                    print(wdnrpgtools.brightscreen())
                    winsound.Beep(349, 100)
                    time.sleep(.5)
                    os.system('cls')
                    wdnrpgtools.statsandmenu(health, potions, arrows, sworddur, shielddur, chainavail, ninjaavail, orchp)
                    print("Enter \n\"A\" - Attack, \n\"D\" - Defend, \n\"R\" - Ranged Attack, \n\"H\" - Hand-to-Hand, \n\"X\" - Health Potion, \n\"C\" - Chain Lightning, \n\"N\" - Ninja Attack.")
                    print("\n******************************************************************************")
                    print(wdnrpgtools.darkscreen())
                    winsound.Beep(294, 300)
                    time.sleep(.5)
                os.system('cls')
                wdnrpgtools.statsandmenu(health, potions, arrows, sworddur, shielddur, chainavail, ninjaavail, orchp)
                print("Enter \n\"A\" - Attack, \n\"D\" - Defend, \n\"R\" - Ranged Attack, \n\"H\" - Hand-to-Hand, \n\"X\" - Health Potion, \n\"C\" - Chain Lightning, \n\"N\" - Ninja Attack.")
                print("\n******************************************************************************")
                print("You become shadow, and unleash a flurry of sword attacks.")
                #Ninja Attack hits X times, random damage each 1~40.   Assign damage to the Orc.
                for i in ninjatimes:
                    iterationdamage = random.randint(1, 40)
                    print("You deal " + str(iterationdamage) + " to the Orc.")
                    totalninjadamage = (totalninjadamage + iterationdamage)
                print("Totalling " + str(totalninjadamage) + ".")
                print(wdnrpgtools.playerninscreen())
                orchp = (orchp - totalninjadamage)
                input("Press the enter key to continue.")
                print("\n\n")
                #roll a D20.  12+, the orc hits
                orcroll = random.randint(1, 20)
                if orcroll >= 12:
                    if orcroll >= 18:
                        health = (health - orccrit)
                        print("Critical Hit!  The Orc wades through your lightning to pancake you.")
                        print("The orc hits you for " + str(orccrit) + " damage.")
                        print(wdnrpgtools.playerninorcscreen())
                    else:
                        health = (health - orcattack)
                        print("The orc hits you for " + str(orcattack) + " damage.")
                        print(wdnrpgtools.playerninorcscreen())
                else:
                    print("The Orc missed.")
                    
            else:
                print("You step into the shadows, and find only failure.")
            input("\nPress the enter key to continue.")
            os.system('cls')







        #Print the appropriate Game Ending:

        #if player health is at zero,  inform the player and quit the game.
        if health <= 0 and orchp > 0:
            print("You have died.  The Orc eventually heals its wounds and ravages the land.")
            print("Your Health  = " + str(health))
            print("Orc's Health = " + str(orchp))
            print(wdnrpgtools.playerloosesscreen())
            input("\n\nPress the enter key to exit.")
            quit()


        #if orc is killed,  inform the player and quit the game.
        if orchp <= 0 and health > 0:
            print("You have defeated the Orc.  \nStepping over its corpse, you head to the castle to receive your reward.")
            print("Your Health  = " + str(health))
            print("Orc's Health = " + str(orchp))
            print(wdnrpgtools.playerwinsscreen())
            input("\n\nPress the enter key to exit.")
            quit()


        #if both player and orc are killed,  inform the player and quit the game.
        if orchp <= 0 and health <= 0:
            print("You and the Orc have killed each other.  \nYou have died, but also saved the land from this vile beast.  You will be rewarded by the king posthumously.")
            print("Your Health  = " + str(health))
            print("Orc's Health = " + str(orchp))
            print(wdnrpgtools.gameoverscreen())
            input("\n\nPress the enter key to exit.")
            quit()




            
            






                   

